package de.unirostock.FactoryMethod.example.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

import de.unirostock.FactoryMethod.example.OilTanker;
import de.unirostock.FactoryMethod.example.RepairDock;
import de.unirostock.FactoryMethod.example.SailingBoat;


public class ShipRepairPanel extends javax.swing.JPanel
implements ActionListener
{
	private	OilTanker	itsOilTanker;
	private	SailingBoat	itsSailingBoat;
	private	RepairDock	itsRepairDock;
	
	private JCheckBox cbOilTankerRepairTanks;
	private JCheckBox cbOilTankerRepairEngine;
	private JCheckBox cbSailingBoatRepairSails;
	private JCheckBox cbSailingBoatRepairHull;
	
	private JLabel	imgShipPlan;
	private JButton btRepairSailingBoat;
	private JButton btRepairOilTanker;
	
	private JLabel	labPartsToRepair;
	private JButton btExeRepair;

	private final static String	CB_OILTANKER_ENGINE		= "CB_OILTANKER_ENGINE";
	private final static String	CB_OILTANKER_TANKS		= "CB_OILTANKER_TANKS";
	private final static String	CB_SAILINGBOAT_SAILS	= "CB_SAILINGBOAT_SAILS";
	private final static String	CB_SAILINGBOAT_HULL		= "CB_SAILINGBOAT_HULL";
	
	private final static String	BT_REPAIR_OITANKER		= "BT_REPAIR_OITANKER";
	private final static String	BT_REPAIR_SAILINGBOAT	= "BT_REPAIR_SAILINGBOAT";
	private final static String	BT_REPAIR_EXECUTE		= "BT_REPAIR_EXECUTE";
	
	public ShipRepairPanel() {
		super();
		initObj();
		initGUI();
	}
	
	public void actionPerformed( ActionEvent e ){
		String	cmd	= e.getActionCommand();
		
		if( cmd.equals( CB_OILTANKER_ENGINE ))	
			itsOilTanker.setEngineNeedRepair( cbOilTankerRepairEngine.isSelected());
		if( cmd.equals( CB_OILTANKER_TANKS ))	
			itsOilTanker.setOilTanksNeedsRepair( cbOilTankerRepairTanks.isSelected());
		if( cmd.equals( CB_SAILINGBOAT_SAILS ))	
			itsSailingBoat.setSailsNeedsRepair( cbSailingBoatRepairSails.isSelected());
		if( cmd.equals( CB_SAILINGBOAT_HULL ))	
			itsSailingBoat.setHullNeedRepair( cbSailingBoatRepairHull.isSelected());
		
		if( cmd.equals( BT_REPAIR_OITANKER ))
			repairOilTanker();
		if( cmd.equals( BT_REPAIR_SAILINGBOAT ))
			repairSailingBoat();
		if( cmd.equals( BT_REPAIR_EXECUTE ))
			repairExecute();
		repaint();
	}
	
	private void repairOilTanker(){
		imgShipPlan.setIcon( itsOilTanker.getImgIcon());
		itsRepairDock.repairShip( itsOilTanker );
		
		String[]	parts	= itsRepairDock.getPartsToRepair();
		String		labText	= null;
		if( parts.length == 0 )
			labText	= "nichts zu reparieren";
		if( parts.length == 1 )
			labText	= parts[0];
		if( parts.length == 2 )
			labText	= parts[0]+", "+parts[1];
		labPartsToRepair.setText( labText );
		cbOilTankerRepairEngine.setEnabled( false );
		cbOilTankerRepairTanks.setEnabled( false );
		cbSailingBoatRepairSails.setEnabled( true );
		cbSailingBoatRepairHull.setEnabled( true );
	}
	
	private void repairSailingBoat(){
		imgShipPlan.setIcon( itsSailingBoat.getImgIcon());
		itsRepairDock.repairShip( itsSailingBoat );
		
		String[]	parts	= itsRepairDock.getPartsToRepair();
		String		labText	= null;
		if( parts.length == 0 )
			labText	= "nichts zu reparieren";
		if( parts.length == 1 )
			labText	= parts[0];
		if( parts.length == 2 )
			labText	= parts[0]+", "+parts[1];
		labPartsToRepair.setText( labText );
		cbOilTankerRepairEngine.setEnabled( true );
		cbOilTankerRepairTanks.setEnabled( true );
		cbSailingBoatRepairSails.setEnabled( false );
		cbSailingBoatRepairHull.setEnabled( false );
	}
	
	private void repairExecute(){
		itsRepairDock.executeRepair();
		imgShipPlan.setIcon( null );
		labPartsToRepair.setText( "" );
		cbOilTankerRepairEngine.setSelected( itsOilTanker.isEngineNeedRepair());
		cbOilTankerRepairTanks.setSelected( itsOilTanker.isOilTanksNeedsRepair());
		cbSailingBoatRepairSails.setSelected( itsSailingBoat.isSailsNeedsRepair());
		cbSailingBoatRepairHull.setSelected( itsSailingBoat.isHullNeedRepair());
		cbOilTankerRepairEngine.setEnabled( true );
		cbOilTankerRepairTanks.setEnabled( true );
		cbSailingBoatRepairSails.setEnabled( true );
		cbSailingBoatRepairHull.setEnabled( true );
	}
	
	private void initObj(){
		itsOilTanker	= new OilTanker();
		itsSailingBoat	= new SailingBoat();
		itsRepairDock	= new RepairDock();
	}
	
	private void initGUI() {
		try {
			this.setPreferredSize(new java.awt.Dimension(649, 290));
			this.setLayout(null);
			this.setBackground(new java.awt.Color(255,255,255));
			{
				JPanel panel = new JPanel();
				this.add(panel);
				panel.setLayout(null);
				panel.setBounds(10, 10, 243, 130);
				panel.setBackground(new java.awt.Color(250,248,238));
				panel.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, false));
				{
					JLabel imgLabel = new JLabel();
					panel.add(imgLabel);
					imgLabel.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/OilTanker.gif")));
					imgLabel.setBounds(5, 4, 233, 41);
				}
				{
					cbOilTankerRepairEngine = new JCheckBox();
					panel.add(cbOilTankerRepairEngine);
					cbOilTankerRepairEngine.setText("Maschine kaputt");
					cbOilTankerRepairEngine.setBounds(20, 60, 180, 20);
					cbOilTankerRepairEngine.setBackground(new java.awt.Color(250,248,238));
					cbOilTankerRepairEngine.setFont(new java.awt.Font("Arial",0,12));
					cbOilTankerRepairEngine.setActionCommand( CB_OILTANKER_ENGINE );
					cbOilTankerRepairEngine.addActionListener( this );
				}
				{
					cbOilTankerRepairTanks = new JCheckBox();
					panel.add(cbOilTankerRepairTanks);
					cbOilTankerRepairTanks.setText("ltanks undicht");
					cbOilTankerRepairTanks.setBounds(20, 90, 180, 20);
					cbOilTankerRepairTanks.setBackground(new java.awt.Color(250,248,238));
					cbOilTankerRepairTanks.setFont(new java.awt.Font("Arial",0,12));
					cbOilTankerRepairTanks.setActionCommand( CB_OILTANKER_TANKS );
					cbOilTankerRepairTanks.addActionListener( this );
				}
			}
			{
				JPanel panel = new JPanel();
				this.add(panel);
				panel.setLayout(null);
				panel.setBounds(10, 150, 243, 130);
				panel.setBackground(new java.awt.Color(250,248,238));
				panel.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, false));
				{
					JLabel imgLabel = new JLabel();
					panel.add(imgLabel);
					imgLabel.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/SailingBoat.gif")));
					imgLabel.setBounds(5, 4, 233, 41);
				}
				{
					cbSailingBoatRepairSails = new JCheckBox();
					panel.add(cbSailingBoatRepairSails);
					cbSailingBoatRepairSails.setText("Segel zerissen");
					cbSailingBoatRepairSails.setBounds(20, 60, 180, 20);
					cbSailingBoatRepairSails.setBackground(new java.awt.Color(250,248,238));
					cbSailingBoatRepairSails.setFont(new java.awt.Font("Arial",0,12));
					cbSailingBoatRepairSails.setActionCommand( CB_SAILINGBOAT_SAILS );
					cbSailingBoatRepairSails.addActionListener( this );
				}
				{
					cbSailingBoatRepairHull = new JCheckBox();
					panel.add(cbSailingBoatRepairHull);
					cbSailingBoatRepairHull.setText("Rumpf ist morsch");
					cbSailingBoatRepairHull.setBounds(20, 90, 180, 20);
					cbSailingBoatRepairHull.setBackground(new java.awt.Color(250,248,238));
					cbSailingBoatRepairHull.setFont(new java.awt.Font("Arial",0,12));
					cbSailingBoatRepairHull.setActionCommand( CB_SAILINGBOAT_HULL );
					cbSailingBoatRepairHull.addActionListener( this );
				}
			}
			{
				JPanel panel = new JPanel();
				this.add(panel);
				panel.setBounds(263, 10, 376, 270);
				panel.setLayout(null);
				panel.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, false));
				panel.setBackground(new java.awt.Color(250,248,238));
				{
					JLabel label = new JLabel();
					panel.add(label);
					label.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/RepairDock.gif")));
					label.setBounds(5, 4, 163, 108);
				}
				{
					JLabel label = new JLabel();
					panel.add(label);
					label.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/ShipServicePlan.gif")));
					label.setBounds(178, 4, 193, 41);
				}
				{
					imgShipPlan = new JLabel();
					panel.add(imgShipPlan);
					imgShipPlan.setBounds(178, 63, 193, 41);
					imgShipPlan.setBackground(new java.awt.Color(250,248,238));
				}
				{
					btRepairOilTanker = new JButton();
					panel.add(btRepairOilTanker);
					btRepairOilTanker.setText("nchster ltanker");
					btRepairOilTanker.setBounds(5, 120, 180, 30);
					btRepairOilTanker.setFont(new java.awt.Font("Arial",1,12));
					btRepairOilTanker.setActionCommand( BT_REPAIR_OITANKER );
					btRepairOilTanker.addActionListener( this );
				}
				{
					btRepairSailingBoat = new JButton();
					panel.add(btRepairSailingBoat);
					btRepairSailingBoat.setText("nchstes Segelboot");
					btRepairSailingBoat.setBounds(191, 120, 180, 30);
					btRepairSailingBoat.setFont(new java.awt.Font("Arial",1,12));
					btRepairSailingBoat.setActionCommand( BT_REPAIR_SAILINGBOAT );
					btRepairSailingBoat.addActionListener( this );
				}
				{
					JPanel panelInfo = new JPanel();
					panel.add(panelInfo);
					panelInfo.setLayout(null);
					panelInfo.setBounds(5, 158, 366, 108);
					panelInfo.setBackground(new java.awt.Color(250,248,238));
					panelInfo.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, false));
					{
						JLabel label = new JLabel();
						panelInfo.add(label);
						label.setText("Beschdigte Teile:");
						label.setBounds(10, 20, 110, 20);
					}
					{
						labPartsToRepair = new JLabel();
						panelInfo.add(labPartsToRepair);
						labPartsToRepair.setText("");
						labPartsToRepair.setBounds(135, 20, 200, 20);
						labPartsToRepair.setFont(new java.awt.Font("Arial",0,12));
					}
					{
						btExeRepair = new JButton();
						panelInfo.add(btExeRepair);
						btExeRepair.setText("Reparatur ausfhren");
						btExeRepair.setBounds(130, 65, 200, 30);
						btExeRepair.setFont(new java.awt.Font("Arial",1,12));
						btExeRepair.setActionCommand( BT_REPAIR_EXECUTE );
						btExeRepair.addActionListener( this );
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
